## GtkSizeGroup GtkSizeGroup — Grouping widgets so they request the same size |

## Functions

GtkSizeGroup * | gtk_size_group_new ()
void | gtk_size_group_set_mode ()
GtkSizeGroupMode | gtk_size_group_get_mode ()
void | gtk_size_group_add_widget ()
void | gtk_size_group_remove_widget ()
GSList * | gtk_size_group_get_widgets ()

## Properties

GtkSizeGroupMode | mode | Read / Write

## Types and Values

struct | GtkSizeGroup
enum | GtkSizeGroupMode

## Object Hierarchy

        GObject
        ╰── GtkSizeGroup

## Implemented Interfaces

GtkSizeGroup implements GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

GtkSizeGroup provides a mechanism for grouping a number of widgets together so they all request the same amount of space. This is typically useful when you want a column of widgets to have the same size, but you can’t use a GtkGrid widget.

In detail, the size requested for each widget in a GtkSizeGroup is the maximum of the sizes that would have been requested for each widget in the size group if they were not in the size group. The mode of the size group (see `gtk_size_group_set_mode()`) determines whether this applies to the horizontal size, the vertical size, or both sizes.

Note that size groups only affect the amount of space requested, not the size that the widgets finally receive. If you want the widgets in a GtkSizeGroup to actually be the same size, you need to pack them in such a way that they get the size they request and not more. For example, if you are packing your widgets into a table, you would not include the `GTK_FILL` flag.

GtkSizeGroup objects are referenced by each widget in the size group, so once you have added all widgets to a GtkSizeGroup, you can drop the initial reference to the size group with `g_object_unref()`. If the widgets in the size group are subsequently destroyed, then they will be removed from the size group and drop their references on the size group; when all widgets have been removed, the size group will be freed.

Widgets can be part of multiple size groups; GTK+ will compute the horizontal size of a widget from the horizontal requisition of all widgets that can be reached from the widget by a chain of size groups of type `GTK_SIZE_GROUP_HORIZONTAL` or `GTK_SIZE_GROUP_BOTH`, and the vertical size from the vertical requisition of all widgets that can be reached from the widget by a chain of size groups of type `GTK_SIZE_GROUP_VERTICAL` or `GTK_SIZE_GROUP_BOTH`.

Note that only non-contextual sizes of every widget are ever consulted by size groups (since size groups have no knowledge of what size a widget will be allocated in one dimension, it cannot derive how much height a widget will receive for a given width). When grouping widgets that trade height for width in mode `GTK_SIZE_GROUP_VERTICAL` or `GTK_SIZE_GROUP_BOTH`: the height for the minimum width will be the requested height for all widgets in the group. The same is of course true when horizontally grouping width for height widgets.

Widgets that trade height-for-width should set a reasonably large minimum width by way of “width-chars” for instance. Widgets with static sizes as well as widgets that grow (such as ellipsizing text) need no such considerations.

### GtkSizeGroup as GtkBuildable

Size groups can be specified in a UI definition by placing an <object> element with `class="GtkSizeGroup"` somewhere in the UI definition. The widgets that belong to the size group are specified by a <widgets> element that may contain multiple <widget> elements, one for each member of the size group. The ”name” attribute gives the id of the widget.

An example of a UI definition fragment with GtkSizeGroup:

    1
    2
    3
    4
    5
    6
    7
    <object class="GtkSizeGroup">
      <property name="mode">horizontal</property>
      <widgets>
        <widget name="radio1"/>
        <widget name="radio2"/>
      </widgets>
    </object>

## Functions

### gtk_size_group_new ()

    GtkSizeGroup *
    gtk_size_group_new (GtkSizeGroupMode mode);

Create a new GtkSizeGroup.

#### Parameters

mode | the mode for the new size group. |

#### Returns

a newly created GtkSizeGroup

### gtk_size_group_set_mode ()

    void
    gtk_size_group_set_mode (GtkSizeGroup *size_group,
                             GtkSizeGroupMode mode);

Sets the GtkSizeGroupMode of the size group. The mode of the size group determines whether the widgets in the size group should all have the same horizontal requisition (`GTK_SIZE_GROUP_HORIZONTAL`) all have the same vertical requisition (`GTK_SIZE_GROUP_VERTICAL`), or should all have the same requisition in both directions (`GTK_SIZE_GROUP_BOTH`).

#### Parameters

size_group | a GtkSizeGroup |
mode | the mode to set for the size group. |

### gtk_size_group_get_mode ()

    GtkSizeGroupMode
    gtk_size_group_get_mode (GtkSizeGroup *size_group);

Gets the current mode of the size group. See `gtk_size_group_set_mode()`.

#### Parameters

size_group | a GtkSizeGroup |

#### Returns

the current mode of the size group.

### gtk_size_group_add_widget ()

    void
    gtk_size_group_add_widget (GtkSizeGroup *size_group,
                               GtkWidget *widget);

Adds a widget to a GtkSizeGroup. In the future, the requisition of the widget will be determined as the maximum of its requisition and the requisition of the other widgets in the size group. Whether this applies horizontally, vertically, or in both directions depends on the mode of the size group. See `gtk_size_group_set_mode()`.

When the widget is destroyed or no longer referenced elsewhere, it will be removed from the size group.

#### Parameters

size_group | a GtkSizeGroup |
widget | the GtkWidget to add |

### gtk_size_group_remove_widget ()

    void
    gtk_size_group_remove_widget (GtkSizeGroup *size_group,
                                  GtkWidget *widget);

Removes a widget from a GtkSizeGroup.

#### Parameters

size_group | a GtkSizeGroup |
widget | the GtkWidget to remove |

### gtk_size_group_get_widgets ()

    GSList *
    gtk_size_group_get_widgets (GtkSizeGroup *size_group);

Returns the list of widgets associated with `size_group` .

#### Parameters

size_group | a GtkSizeGroup |

#### Returns

a GSList of widgets. The list is owned by GTK+ and should not be modified.

[element-type GtkWidget][transfer none]

## Types and Values

### struct GtkSizeGroup

    struct GtkSizeGroup;

### enum GtkSizeGroupMode

The mode of the size group determines the directions in which the size group affects the requested sizes of its component widgets.

#### Members

GTK_SIZE_GROUP_NONE | group has no effect |
GTK_SIZE_GROUP_HORIZONTAL | group affects horizontal requisition |
GTK_SIZE_GROUP_VERTICAL | group affects vertical requisition |
GTK_SIZE_GROUP_BOTH | group affects both horizontal and vertical requisition |

## Property Details

### The `“mode”` property

      “mode”                     GtkSizeGroupMode

The directions in which the size group affects the requested sizes of its component widgets.

Owner: GtkSizeGroup

Flags: Read / Write

Default value: GTK_SIZE_GROUP_HORIZONTAL